Index: /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/METO_GO/EXPREF/file_def_nemo-ice-BASIC-10D.xml
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/METO_GO/EXPREF/file_def_nemo-ice-BASIC-10D.xml	(revision 12922)
+++ /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/METO_GO/EXPREF/file_def_nemo-ice-BASIC-10D.xml	(revision 12923)
@@ -86,5 +86,21 @@
        <field field_ref="icetemp_cat"      name="sitemcat"/>
        <field field_ref="snwtemp_cat"      name="sntemcat"/>
-       
+
+       <!-- mass balance -->
+       <field field_ref="dmithd"           name="sidmassth"        />
+       <field field_ref="dmidyn"           name="sidmassdyn"       />
+       <field field_ref="dmiopw"           name="sidmassgrowthwat" />
+       <field field_ref="dmibog"           name="sidmassgrowthbot" />
+       <field field_ref="dmisni"           name="sidmasssi"        />
+       <field field_ref="dmisub"           name="sidmassevapsubl"  />
+       <field field_ref="dmisum"           name="sidmassmelttop"   />
+       <field field_ref="dmibom"           name="sidmassmeltbot"   />
+       <field field_ref="dmilam"           name="sidmassmeltlat"   />
+       <field field_ref="dmsspr"           name="sndmasssnf"       />
+       <field field_ref="dmsmel"           name="sndmassmelt"      />
+       <field field_ref="dmssub"           name="sndmasssubl"      />
+       <field field_ref="dmsdyn"           name="sndmassdyn"       />
+       <field field_ref="dmsssi"           name="sndmasssi"        />
+
      </file>
      
Index: /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/METO_GO/EXPREF/file_def_nemo-ice-BASIC-1M.xml
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/METO_GO/EXPREF/file_def_nemo-ice-BASIC-1M.xml	(revision 12922)
+++ /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/METO_GO/EXPREF/file_def_nemo-ice-BASIC-1M.xml	(revision 12923)
@@ -86,5 +86,21 @@
        <field field_ref="icetemp_cat"      name="sitemcat"/>
        <field field_ref="snwtemp_cat"      name="sntemcat"/>
-       
+
+       <!-- mass balance -->
+       <field field_ref="dmithd"           name="sidmassth"        />
+       <field field_ref="dmidyn"           name="sidmassdyn"       />
+       <field field_ref="dmiopw"           name="sidmassgrowthwat" />
+       <field field_ref="dmibog"           name="sidmassgrowthbot" />
+       <field field_ref="dmisni"           name="sidmasssi"        />
+       <field field_ref="dmisub"           name="sidmassevapsubl"  />
+       <field field_ref="dmisum"           name="sidmassmelttop"   />
+       <field field_ref="dmibom"           name="sidmassmeltbot"   />
+       <field field_ref="dmilam"           name="sidmassmeltlat"   />
+       <field field_ref="dmsspr"           name="sndmasssnf"       />
+       <field field_ref="dmsmel"           name="sndmassmelt"      />
+       <field field_ref="dmssub"           name="sndmasssubl"      />
+       <field field_ref="dmsdyn"           name="sndmassdyn"       />
+       <field field_ref="dmsssi"           name="sndmasssi"        />
+
      </file>
      
Index: /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/METO_GO/EXPREF/file_def_nemo-ice-CMIP6-10D.xml
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/METO_GO/EXPREF/file_def_nemo-ice-CMIP6-10D.xml	(revision 12922)
+++ /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/METO_GO/EXPREF/file_def_nemo-ice-CMIP6-10D.xml	(revision 12923)
@@ -87,4 +87,20 @@
        <field field_ref="snwtemp_cat"      name="sntemcat"/>
        
+       <!-- mass balance -->
+       <field field_ref="dmithd"           name="sidmassth"        />
+       <field field_ref="dmidyn"           name="sidmassdyn"       />
+       <field field_ref="dmiopw"           name="sidmassgrowthwat" />
+       <field field_ref="dmibog"           name="sidmassgrowthbot" />
+       <field field_ref="dmisni"           name="sidmasssi"        />
+       <field field_ref="dmisub"           name="sidmassevapsubl"  />
+       <field field_ref="dmisum"           name="sidmassmelttop"   />
+       <field field_ref="dmibom"           name="sidmassmeltbot"   />
+       <field field_ref="dmilam"           name="sidmassmeltlat"   />
+       <field field_ref="dmsspr"           name="sndmasssnf"       />
+       <field field_ref="dmsmel"           name="sndmassmelt"      />
+       <field field_ref="dmssub"           name="sndmasssubl"      />
+       <field field_ref="dmsdyn"           name="sndmassdyn"       />
+       <field field_ref="dmsssi"           name="sndmasssi"        />
+
      </file>
      
Index: /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/METO_GO/EXPREF/file_def_nemo-ice-CMIP6-1M.xml
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/METO_GO/EXPREF/file_def_nemo-ice-CMIP6-1M.xml	(revision 12922)
+++ /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/METO_GO/EXPREF/file_def_nemo-ice-CMIP6-1M.xml	(revision 12923)
@@ -87,4 +87,20 @@
        <field field_ref="snwtemp_cat"      name="sntemcat"/>
        
+       <!-- mass balance -->
+       <field field_ref="dmithd"           name="sidmassth"        />
+       <field field_ref="dmidyn"           name="sidmassdyn"       />
+       <field field_ref="dmiopw"           name="sidmassgrowthwat" />
+       <field field_ref="dmibog"           name="sidmassgrowthbot" />
+       <field field_ref="dmisni"           name="sidmasssi"        />
+       <field field_ref="dmisub"           name="sidmassevapsubl"  />
+       <field field_ref="dmisum"           name="sidmassmelttop"   />
+       <field field_ref="dmibom"           name="sidmassmeltbot"   />
+       <field field_ref="dmilam"           name="sidmassmeltlat"   />
+       <field field_ref="dmsspr"           name="sndmasssnf"       />
+       <field field_ref="dmsmel"           name="sndmassmelt"      />
+       <field field_ref="dmssub"           name="sndmasssubl"      />
+       <field field_ref="dmsdyn"           name="sndmassdyn"       />
+       <field field_ref="dmsssi"           name="sndmasssi"        />
+
      </file>
      
Index: /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/ORCA2_ICE_PISCES/EXPREF/file_def_nemo-ice.xml
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/ORCA2_ICE_PISCES/EXPREF/file_def_nemo-ice.xml	(revision 12922)
+++ /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/ORCA2_ICE_PISCES/EXPREF/file_def_nemo-ice.xml	(revision 12923)
@@ -28,7 +28,7 @@
        <field field_ref="iceapnd"          name="siapnd" />
        <field field_ref="icevpnd"          name="sivpnd" />
-       <field field_ref="sst_m"            name="sst_m"  />
-       <field field_ref="sss_m"            name="sss_m"  />
-       
+       <field field_ref="sst_m_pot"        name="sst_m_pot"  />
+       <field field_ref="sss_m_abs"        name="sss_m_abs"  />
+
        <!-- heat -->
        <field field_ref="icetemp"          name="sitemp" />
Index: /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/ORCA2_ICE_PISCES/EXPREF/file_def_nemo-oce.xml
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/ORCA2_ICE_PISCES/EXPREF/file_def_nemo-oce.xml	(revision 12922)
+++ /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/ORCA2_ICE_PISCES/EXPREF/file_def_nemo-oce.xml	(revision 12923)
@@ -14,12 +14,12 @@
         <file id="file11" name_suffix="_grid_T" description="ocean T grid variables" >
           <field field_ref="e3t"      />
-          <field field_ref="toce"         name="thetao"                                                                      operation="instant" freq_op="5d" > @toce_e3t / @e3t </field>
-          <field field_ref="soce"         name="so"                                                                          operation="instant" freq_op="5d" > @soce_e3t / @e3t </field>
-          <field field_ref="sst"          name="tos"   />
-          <field field_ref="sss"          name="sos"   />
+          <field field_ref="toce_con"         name="thetao_con"                                                                      operation="instant" freq_op="5d" > @toce_con_e3t / @e3t </field>
+          <field field_ref="soce_abs"         name="so_abs"                                                                          operation="instant" freq_op="5d" > @soce_abs_e3t / @e3t </field>
+          <field field_ref="sst_con"          name="tos_con"   />
+          <field field_ref="sss_abs"          name="sos_abs"   />
           <field field_ref="ssh"          name="zos"   />
-          <field field_ref="sst"          name="tosstd"       long_name="sea surface temperature standard deviation"         operation="instant" freq_op="5d" > sqrt( @sst2 - @sst * @sst ) </field>
+          <field field_ref="sst_con"          name="tosstd_con"       long_name="sea surface temperature standard deviation"         operation="instant" freq_op="5d" > sqrt( @sst2_con - @sst_con * @sst_con ) </field>
           <field field_ref="ssh"          name="zosstd"       long_name="sea surface height above geoid standard deviation"  operation="instant" freq_op="5d" > sqrt( @ssh2 - @ssh * @ssh ) </field>
-          <field field_ref="sst"          name="sstdcy"       long_name="amplitude of sst diurnal cycle"                     operation="average" freq_op="1d" > @sstmax - @sstmin </field>
+          <field field_ref="sst_con"          name="sstdcy_con"       long_name="amplitude of sst diurnal cycle"                     operation="average" freq_op="1d" > @sstmax_con - @sstmin_con </field>
           <field field_ref="mldkz5"   />
           <field field_ref="mldr10_1" />
Index: /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/SHARED/field_def_nemo-ice.xml
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/SHARED/field_def_nemo-ice.xml	(revision 12922)
+++ /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/SHARED/field_def_nemo-ice.xml	(revision 12923)
@@ -213,4 +213,5 @@
           <field id="dmisum"       long_name="sea-ice mass change through surface melting"             standard_name="tendency_of_sea_ice_amount_due_to_surface_melting"                       unit="kg/m2/s" />
           <field id="dmibom"       long_name="sea-ice mass change through bottom melting"              standard_name="tendency_of_sea_ice_amount_due_to_basal_melting"                         unit="kg/m2/s" />
+	  <field id="dmilam"       long_name="sea-ice mass change through lateral melting"             standard_name="tendency_of_sea_ice_amount_due_to_lateral_melting"                       unit="kg/m2/s" />
           <field id="dmsspr"       long_name="snow mass change through snow fall"                      standard_name="snowfall_flux"                                                           unit="kg/m2/s" />
           <field id="dmsmel"       long_name="snow mass change through melt"                           standard_name="surface_snow_melt_flux"                                                  unit="kg/m2/s" />
@@ -244,35 +245,20 @@
          <field id="xmtrpice_ave"     long_name="Monthly average of x-ice mass transport"   field_ref="xmtrpice"          grid_ref="grid_U_2D"        freq_op="1mo" freq_offset="_reset_"  > @xmtrpice </field>
          <field id="xmtrpice_section"                                                                                     grid_ref="grid_U_scalar"  > xmtrpice_ave </field>
-         <field id="xmtrpice_strait"                                                        field_ref="xmtrpice_section"  grid_ref="grid_U_4strait_ice"  />
-         <field id="xstrait_mifl"                                                           field_ref="xmtrpice_strait"   grid_ref="grid_U_4strait_ice_hsum" unit="kg/s" detect_missing_value="true" > this * maskMFO_u_ice </field>
 
          <field id="ymtrpice_ave"     long_name="Monthly average of y-ice mass transport"   field_ref="ymtrpice"          grid_ref="grid_V_2D"        freq_op="1mo" freq_offset="_reset_"  > @ymtrpice </field>
          <field id="ymtrpice_section"                                                                                     grid_ref="grid_V_scalar"  > ymtrpice_ave </field>
-         <field id="ymtrpice_strait"                                                        field_ref="ymtrpice_section"  grid_ref="grid_V_4strait_ice"  />
-	 <field id="ystrait_mifl"                                                           field_ref="ymtrpice_strait"   grid_ref="grid_V_4strait_ice_hsum" unit="kg/s" detect_missing_value="true"  > this * maskMFO_v_ice </field>
 
          <field id="xmtrpsnw_ave"     long_name="Monthly average of x-snow mass transport"  field_ref="xmtrpsnw"          grid_ref="grid_U_2D"        freq_op="1mo" freq_offset="_reset_"  > @xmtrpsnw </field>
          <field id="xmtrpsnw_section"                                                                                     grid_ref="grid_U_scalar"  > xmtrpsnw_ave </field>
-         <field id="xmtrpsnw_strait"                                                        field_ref="xmtrpsnw_section"  grid_ref="grid_U_4strait_ice"  />
-         <field id="xstrait_msfl"                                                           field_ref="xmtrpsnw_strait"   grid_ref="grid_U_4strait_ice_hsum" unit="kg/s" detect_missing_value="true" > this * maskMFO_u_ice </field>
 
          <field id="ymtrpsnw_ave"     long_name="Monthly average of y-snow mass transport"  field_ref="ymtrpsnw"          grid_ref="grid_V_2D"        freq_op="1mo" freq_offset="_reset_"  > @ymtrpsnw </field>
          <field id="ymtrpsnw_section"                                                                                     grid_ref="grid_V_scalar"  > ymtrpsnw_ave </field>
-         <field id="ymtrpsnw_strait"                                                        field_ref="ymtrpsnw_section"  grid_ref="grid_V_4strait_ice"  />
-	 <field id="ystrait_msfl"                                                           field_ref="ymtrpsnw_strait"   grid_ref="grid_V_4strait_ice_hsum" unit="kg/s" detect_missing_value="true"  > this * maskMFO_v_ice </field>
 
          <field id="xatrp_ave"        long_name="Monthly average of x-ice area transport"   field_ref="xatrp"             grid_ref="grid_U_2D"        freq_op="1mo" freq_offset="_reset_"  > @xatrp </field>
          <field id="xatrp_section"                                                                                        grid_ref="grid_U_scalar"  > xatrp_ave </field>
-         <field id="xatrp_strait"                                                           field_ref="xatrp_section"     grid_ref="grid_U_4strait_ice"  />
-         <field id="xstrait_arfl"                                                           field_ref="xatrp_strait"      grid_ref="grid_U_4strait_ice_hsum" unit="kg/s" detect_missing_value="true" > this * maskMFO_u_ice </field>
 
          <field id="yatrp_ave"        long_name="Monthly average of y-ice area transport"   field_ref="yatrp"             grid_ref="grid_V_2D"        freq_op="1mo" freq_offset="_reset_"  > @yatrp </field>
          <field id="yatrp_section"                                                                                        grid_ref="grid_V_scalar"  > yatrp_ave </field>
-         <field id="yatrp_strait"                                                           field_ref="yatrp_section"     grid_ref="grid_V_4strait_ice"  />
-	 <field id="ystrait_arfl"                                                           field_ref="yatrp_strait"      grid_ref="grid_V_4strait_ice_hsum" unit="m2/s" detect_missing_value="true"  > this * maskMFO_v_ice </field>
-
-         <field id="strait_mifl"      long_name="Sea ice mass flux through straits"      standard_name="sea_ice_mass_transport_across_line"   unit="kg/s"  freq_op="1mo"  grid_ref="grid_4strait_ice" > xstrait_mifl + ystrait_mifl </field>
-         <field id="strait_msfl"      long_name="Snow mass flux through straits"         standard_name="snow_mass_transport_across_line"      unit="kg/s"  freq_op="1mo"  grid_ref="grid_4strait_ice" > xstrait_msfl + ystrait_msfl </field>
-	 <field id="strait_arfl"      long_name="Sea ice area flux through straits"      standard_name="sea_area_mass_transport_across_line"  unit="m2/s"  freq_op="1mo"  grid_ref="grid_4strait_ice" > xstrait_arfl + ystrait_arfl </field>
+
 
 	</field_group> <!-- SBC_2D -->
@@ -565,4 +551,5 @@
           <field field_ref="dmisum"           name="sidmassmelttop"   />
           <field field_ref="dmibom"           name="sidmassmeltbot"   />
+          <field field_ref="dmilam"           name="sidmassmeltlat"   />
           <field field_ref="dmsspr"           name="sndmasssnf"       />
           <field field_ref="dmsmel"           name="sndmassmelt"      />
Index: /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/SHARED/field_def_nemo-oce.xml
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/SHARED/field_def_nemo-oce.xml	(revision 12922)
+++ /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/SHARED/field_def_nemo-oce.xml	(revision 12923)
@@ -27,5 +27,10 @@
 	<field id="masscello"    long_name="Sea Water Mass per unit area"   standard_name="sea_water_mass_per_unit_area"   unit="kg/m2"   grid_ref="grid_T_3D"/>
         <field id="volcello"     long_name="Ocean Volume"                   standard_name="ocean_volume"   unit="m3"       grid_ref="grid_T_3D"/> 
-        
+        <field id="e3tb"         long_name="bottom T-cell thickness"             standard_name="bottom_cell_thickness" unit="m"   grid_ref="grid_T_2D"/>
+        <field id="e3t_300"      field_ref="e3t"                grid_ref="grid_T_zoom_300"       detect_missing_value="true" />
+	<field id="e3t_vsum300"  field_ref="e3t_300"            grid_ref="grid_T_vsum"   detect_missing_value="true" />
+	<field id="masscello"    long_name="Sea Water Mass per unit area"   standard_name="sea_water_mass_per_unit_area"   unit="kg/m2"   grid_ref="grid_T_3D"/>
+        <field id="volcello"     long_name="Ocean Volume"                   standard_name="ocean_volume"   unit="m3"       grid_ref="grid_T_3D"/>
+
         <!-- EOS80 -->
         <field id="toce_pot"         long_name="potential temperature"           standard_name="sea_water_potential_temperature"      unit="degC"     grid_ref="grid_T_3D"/>
@@ -655,14 +660,9 @@
          <field id="uoce_e3u_ave_vsum"    long_name="Vertical sum of u*e3u"                           field_ref="uoce_e3u_ave"         grid_ref="grid_U_vsum"     />
          <field id="uocetr_vsum_section"  long_name="Total 2D transport in i-direction"               field_ref="uoce_e3u_ave_vsum"    grid_ref="grid_U_scalar"  detect_missing_value="true"> this * e2u </field>
-         <field id="uocetr_strait"        long_name="Total transport across lines in i-direction"     field_ref="uocetr_vsum_section"  grid_ref="grid_U_4strait" />
-         <field id="u_masstr_strait"      long_name="Sea water transport across line in i-direction"  field_ref="uocetr_strait"        grid_ref="grid_U_4strait_hsum" unit="kg/s"> this * maskMFO_u * $rau0 </field>
 
          <field id="voce_e3v_ave"         long_name="Monthly average of v*e3v"                        field_ref="voce_e3v"                    freq_op="1mo"   freq_offset="_reset_" > @voce_e3v </field>
          <field id="voce_e3v_ave_vsum"    long_name="Vertical sum of v*e3v"                           field_ref="voce_e3v_ave"         grid_ref="grid_V_vsum"      />
          <field id="vocetr_vsum_section"  long_name="Total 2D transport of in j-direction"            field_ref="voce_e3v_ave_vsum"    grid_ref="grid_V_scalar"  detect_missing_value="true"> this * e1v </field>
-         <field id="vocetr_strait"        long_name="Total transport across lines in j-direction"     field_ref="vocetr_vsum_section"  grid_ref="grid_V_4strait"  />
-         <field id="v_masstr_strait"      long_name="Sea water transport across line in j-direction"  field_ref="vocetr_strait"        grid_ref="grid_V_4strait_hsum" unit="kg/s"> this * maskMFO_v * $rau0 </field>
-
-         <field id="masstr_strait"        long_name="Sea water transport across line"                                                  grid_ref="grid_4strait"  > u_masstr_strait + v_masstr_strait </field>
+
       </field_group>
 
Index: /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/SHARED/grid_def_nemo.xml
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/SHARED/grid_def_nemo.xml	(revision 12922)
+++ /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/SHARED/grid_def_nemo.xml	(revision 12923)
@@ -20,9 +20,4 @@
          <domain domain_ref="grid_T" />
          <axis axis_ref="deptht" />
-       </grid>
-        <!--  -->
-       <grid id="grid_T_3DS" >
-         <domain domain_ref="grid_T" />
-         <axis axis_ref="profsed" />
        </grid>
         <!--  -->
@@ -67,40 +62,4 @@
        </grid>
         <!--  -->
-
-
-       <grid id="grid_znl_T_2D">
-         <domain domain_ref="gznl" />
-         <axis axis_ref="basin" />
-       </grid>
-
-       <grid id="grid_znl_T_3D">
-         <domain domain_ref="gznl" />
-         <axis axis_ref="deptht"  />
-         <axis axis_ref="basin" />
-       </grid>
-
-       <grid id="grid_znl_W_3D">
-         <domain domain_ref="gznl" />
-         <axis axis_ref="depthw"  />
-         <axis axis_ref="basin" />
-       </grid>
-
-      <grid id="grid_ptr_T_2D">
-         <domain domain_ref="ptr" />
-         <axis axis_ref="basin" />
-       </grid>
-
-       <grid id="grid_ptr_T_3D">
-         <domain  domain_ref="ptr" />
-         <axis axis_ref="deptht"  />
-         <axis axis_ref="basin" />
-       </grid>
-
-       <grid id="grid_ptr_W_3D">
-         <domain  domain_ref="ptr" />
-         <axis axis_ref="depthw"  />
-         <axis axis_ref="basin" />
-       </grid>
-
        <grid id="grid_ptr_W_GLO">
          <domain  domain_ref="ptr" />
@@ -155,25 +114,4 @@
        </grid>
 
-       <!-- for ORCA2 grid  -->
-       <grid id="cumul_U">
-         <axis axis_ref="cumul_U" n_glo="182" >
-           <reduce_domain local="true" operation="sum" direction="jDir" />
-           <reduce_axis operation="sum" />
-         </axis>
-         <axis axis_ref="depthu" />
-       </grid>
-
-       <!-- for eORCA1 grid
-
-       <grid id="cumul_U">
-         <axis axis_ref="cumul_U" n_glo="362" >
-           <reduce_domain local="true" operation="sum" direction="jDir" />
-           <reduce_axis operation="sum" />
-         </axis>
-         <axis axis_ref="depthu" />
-       </grid>
-
-      -->
-
 
        <grid id="grid_T_zoom_300">
@@ -191,72 +129,4 @@
          <scalar/>
        </grid>
- 
-       <grid id="grid_U_4strait">
-         <domain domain_ref="grid_U" />
-         <axis axis_ref="section">
-           <duplicate_scalar/>
-         </axis>
-       </grid>
- 
-       <grid id="grid_V_4strait">
-         <domain domain_ref="grid_V" />
-         <axis axis_ref="section">
-           <duplicate_scalar/>
-         </axis>
-       </grid>
- 
-       <grid id="grid_U_4strait_hsum">
-         <scalar >
-           <reduce_domain operation="sum" local="true"/>
-           <reduce_scalar operation="sum" />
-         </scalar>
-         <axis axis_ref="section"/>
-       </grid>
- 
-       <grid id="grid_V_4strait_hsum">
-         <scalar >
-           <reduce_domain operation="sum" local="true"/>
-           <reduce_scalar operation="sum" />
-         </scalar>
-         <axis axis_ref="section"/>
-       </grid>
- 
-       <grid id="grid_4strait">
-         <axis axis_ref="section"/>
-       </grid>
-
-      <grid id="grid_U_4strait_ice">
-        <domain domain_ref="grid_U" />
-        <axis axis_ref="section_ice">
-          <duplicate_scalar/>
-        </axis>
-      </grid>
-
-      <grid id="grid_V_4strait_ice">
-        <domain domain_ref="grid_V" />
-        <axis axis_ref="section_ice">
-         <duplicate_scalar/>
-        </axis>
-      </grid>
-
-      <grid id="grid_U_4strait_ice_hsum">
-        <scalar >
-         <reduce_domain operation="sum" local="true"/>
-         <reduce_scalar operation="sum" />
-        </scalar>
-        <axis axis_ref="section_ice"/>
-      </grid>
-
-     <grid id="grid_V_4strait_ice_hsum">
-        <scalar >
-         <reduce_domain operation="sum" local="true"/>
-         <reduce_scalar operation="sum" />
-        </scalar>
-        <axis axis_ref="section_ice"/>
-     </grid>
-
-     <grid id="grid_4strait_ice">
-       <axis axis_ref="section_ice"/>
-     </grid>
  
       <!-- scalars -->
Index: /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/SHARED/namelist_ref
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/SHARED/namelist_ref	(revision 12922)
+++ /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/cfgs/SHARED/namelist_ref	(revision 12923)
@@ -759,5 +759,5 @@
 &nameos        !   ocean Equation Of Seawater                           (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_teos10   = .false.         !  = Use TEOS-10
+   ln_teos10   = .true.         !  = Use TEOS-10
    ln_eos80    = .false.         !  = Use EOS80
    ln_seos     = .false.         !  = Use S-EOS (simplified Eq.)
Index: /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/src/ICE/icewri.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/src/ICE/icewri.F90	(revision 12922)
+++ /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/src/ICE/icewri.F90	(revision 12923)
@@ -177,4 +177,5 @@
       IF( iom_use('dmisum') )   CALL iom_put( 'dmisum', - wfx_sum                                                             ) ! Sea-ice mass change through surface melting
       IF( iom_use('dmibom') )   CALL iom_put( 'dmibom', - wfx_bom                                                             ) ! Sea-ice mass change through bottom melting
+      IF( iom_use('dmilam') )   CALL iom_put( 'dmilam', - wfx_lam                                                             ) ! Sea-ice mass change through lateral melting
       IF( iom_use('dmtsub') )   CALL iom_put( 'dmtsub', - wfx_sub                                                             ) ! Sea-ice mass change through evaporation and sublimation
       IF( iom_use('dmssub') )   CALL iom_put( 'dmssub', - wfx_snw_sub                                                         ) ! Snow mass change through sublimation
Index: /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/src/OCE/DOM/dommsk.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/src/OCE/DOM/dommsk.F90	(revision 12922)
+++ /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/src/OCE/DOM/dommsk.F90	(revision 12923)
@@ -95,5 +95,4 @@
       INTEGER  ::   ios
       !!
-      INTEGER  :: inum             !  logical unit for shlat2d
       REAL(wp) :: zshlat           !: locally modified shlat for some strait
       REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: zshlat2d
Index: /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/src/OCE/ZDF/zdftke.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/src/OCE/ZDF/zdftke.F90	(revision 12922)
+++ /NEMO/branches/UKMO/NEMO_4.0.2_GO8_package_ENHANCE-02_ISF_nemo/src/OCE/ZDF/zdftke.F90	(revision 12923)
@@ -220,11 +220,4 @@
          END DO
       END DO
-      IF ( ln_isfcav ) THEN
-         DO jj = 2, jpjm1            ! en(mikt(ji,jj))   = rn_emin
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               en(ji,jj,mikt(ji,jj)) = rn_emin * tmask(ji,jj,1)
-            END DO
-         END DO
-      ENDIF
       !
       !                     !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
@@ -617,5 +610,5 @@
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
-                  p_avt(ji,jj,jk)   = MAX( apdlr(ji,jj,jk) * p_avt(ji,jj,jk), avtb_2d(ji,jj) * avtb(jk) ) * tmask(ji,jj,jk)
+                  p_avt(ji,jj,jk)   = MAX( apdlr(ji,jj,jk) * p_avt(ji,jj,jk), avtb_2d(ji,jj) * avtb(jk) ) * wmask(ji,jj,jk)
               END DO
             END DO