Index: /utils/CI/sette/sette_reference-configurations.sh
===================================================================
--- /utils/CI/sette/sette_reference-configurations.sh	(revision 12930)
+++ /utils/CI/sette/sette_reference-configurations.sh	(revision 12931)
@@ -186,5 +186,4 @@
     set_namelist namelist_cfg jpni 2
     set_namelist namelist_cfg jpnj 4
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg sn_cfctl%l_trcstat .true.
@@ -212,5 +211,4 @@
     set_namelist namelist_cfg jpni 2
     set_namelist namelist_cfg jpnj 4
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg sn_cfctl%l_trcstat .true.
@@ -254,5 +252,4 @@
     set_namelist namelist_cfg jpni 2
     set_namelist namelist_cfg jpnj 4
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg sn_cfctl%l_trcstat .true.
@@ -282,5 +279,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 2
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg sn_cfctl%l_trcstat .true.
@@ -327,5 +323,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg sn_cfctl%l_trcstat .true.
@@ -374,5 +369,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg sn_cfctl%l_trcstat .true.
@@ -443,5 +437,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg sn_cfctl%l_trcstat .true.
@@ -490,5 +483,4 @@
     set_namelist namelist_cfg jpni 8
     set_namelist namelist_cfg jpnj 4
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg sn_cfctl%l_trcstat .true.
@@ -554,5 +546,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg sn_cfctl%l_trcstat .true.
@@ -588,5 +579,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg sn_cfctl%l_trcstat .true.
@@ -637,5 +627,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg sn_cfctl%l_trcstat .true.
@@ -675,5 +664,4 @@
     set_namelist namelist_cfg jpni 8
     set_namelist namelist_cfg jpnj 4
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg sn_cfctl%l_trcstat .true.
@@ -730,5 +718,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -751,5 +738,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg ln_rstart .true.
@@ -790,5 +776,4 @@
     set_namelist namelist_cfg jpni 8
     set_namelist namelist_cfg jpnj 4
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -815,5 +800,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -859,5 +843,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_ice_cfg ln_icediachk .true.
@@ -881,5 +864,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg ln_rstart .true.
@@ -922,5 +904,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -948,5 +929,4 @@
     set_namelist namelist_cfg jpni 8
     set_namelist namelist_cfg jpnj 4
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -995,5 +975,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg sn_cfctl%l_trcstat .true.
@@ -1044,5 +1023,4 @@
     set_namelist namelist_cfg jpni 8
     set_namelist namelist_cfg jpnj 4
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg sn_cfctl%l_trcstat .true.
@@ -1107,5 +1085,4 @@
     set_namelist namelist_cfg nn_itend 20
     set_namelist namelist_cfg nn_stock 10
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 1_namelist_cfg cn_exp \"AGRIF_LONG\"
@@ -1113,5 +1090,4 @@
     set_namelist 1_namelist_cfg nn_itend 20
     set_namelist 1_namelist_cfg nn_stock 10
-    set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 2_namelist_cfg cn_exp \"AGRIF_LONG\"
@@ -1119,5 +1095,4 @@
     set_namelist 2_namelist_cfg nn_itend 80
     set_namelist 2_namelist_cfg nn_stock 40
-    set_namelist 2_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 2_namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 3_namelist_cfg cn_exp \"AGRIF_LONG\"
@@ -1125,5 +1100,4 @@
     set_namelist 3_namelist_cfg nn_itend 240
     set_namelist 3_namelist_cfg nn_stock 120
-    set_namelist 3_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 3_namelist_cfg sn_cfctl%l_runstat .true.
 
@@ -1146,5 +1120,4 @@
     set_namelist namelist_cfg nn_itend 20
     set_namelist namelist_cfg nn_stock 10
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg ln_rstart .true.
@@ -1154,5 +1127,4 @@
     set_namelist 1_namelist_cfg nn_itend 20
     set_namelist 1_namelist_cfg nn_stock 10
-    set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 1_namelist_cfg ln_rstart .true.
@@ -1162,5 +1134,4 @@
     set_namelist 2_namelist_cfg nn_itend 80
     set_namelist 2_namelist_cfg nn_stock 40
-    set_namelist 2_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 2_namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 2_namelist_cfg ln_rstart .true.
@@ -1170,5 +1141,4 @@
     set_namelist 3_namelist_cfg nn_itend 240
     set_namelist 3_namelist_cfg nn_stock 120
-    set_namelist 3_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 3_namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 3_namelist_cfg ln_rstart .true.
@@ -1223,5 +1193,4 @@
     set_namelist namelist_cfg jpni 2
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 1_namelist_cfg cn_exp \"AGRIF_28\"
@@ -1230,5 +1199,4 @@
     set_namelist 1_namelist_cfg jpni 2
     set_namelist 1_namelist_cfg jpnj 8
-    set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 2_namelist_cfg cn_exp \"AGRIF_28\"
@@ -1237,5 +1205,4 @@
     set_namelist 2_namelist_cfg jpni 2
     set_namelist 2_namelist_cfg jpnj 8
-    set_namelist 2_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 2_namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 3_namelist_cfg cn_exp \"AGRIF_28\"
@@ -1244,5 +1211,4 @@
     set_namelist 3_namelist_cfg jpni 2
     set_namelist 3_namelist_cfg jpnj 8
-    set_namelist 3_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 3_namelist_cfg sn_cfctl%l_runstat .true.
 
@@ -1271,5 +1237,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 4
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 1_namelist_cfg cn_exp \"AGRIF_44\"
@@ -1278,5 +1243,4 @@
     set_namelist 1_namelist_cfg jpni 4
     set_namelist 1_namelist_cfg jpnj 4
-    set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 2_namelist_cfg cn_exp \"AGRIF_44\"
@@ -1285,5 +1249,4 @@
     set_namelist 2_namelist_cfg jpni 4
     set_namelist 2_namelist_cfg jpnj 4
-    set_namelist 2_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 2_namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 3_namelist_cfg cn_exp \"AGRIF_44\"
@@ -1292,5 +1255,4 @@
     set_namelist 3_namelist_cfg jpni 4
     set_namelist 3_namelist_cfg jpnj 4
-    set_namelist 3_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 3_namelist_cfg sn_cfctl%l_runstat .true.
 
@@ -1321,5 +1283,4 @@
     set_namelist namelist_cfg nn_it000 1
     set_namelist namelist_cfg nn_itend 150
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
 
@@ -1364,5 +1325,4 @@
     set_namelist namelist_cfg nn_it000 1
     set_namelist namelist_cfg nn_itend 150
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
 #
@@ -1410,5 +1370,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     #set_namelist namelist_ice_cfg ln_icediachk .true.
@@ -1435,5 +1394,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg cn_ocerst_in \"S12_LONG_00000120_restart\"
@@ -1474,5 +1432,4 @@
     set_namelist namelist_cfg jpni 4
     set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -1501,5 +1458,4 @@
     set_namelist namelist_cfg jpni 8
     set_namelist namelist_cfg jpnj 4
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     if [ ${USING_MPMD} == "yes" ] ; then
Index: /utils/CI/sette/sette_test-cases.sh
===================================================================
--- /utils/CI/sette/sette_test-cases.sh	(revision 12930)
+++ /utils/CI/sette/sette_test-cases.sh	(revision 12931)
@@ -186,5 +186,4 @@
     set_namelist namelist_cfg nn_itend 120
     set_namelist namelist_cfg nn_stock 60
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -206,5 +205,4 @@
     set_namelist namelist_cfg nn_itend 120
     set_namelist namelist_cfg nn_stock 60
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg ln_rstart .true.
@@ -288,5 +286,4 @@
     set_namelist namelist_cfg nn_it000 1
     set_namelist namelist_cfg nn_stock 60
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg nn_itend 120
@@ -309,5 +306,4 @@
     set_namelist namelist_cfg nn_itend 120
     set_namelist namelist_cfg nn_stock 60
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg ln_rstart .true.
@@ -393,5 +389,4 @@
     set_namelist namelist_cfg nn_itend 240
     set_namelist namelist_cfg nn_stock 120
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
 
@@ -400,5 +395,4 @@
     set_namelist 1_namelist_cfg nn_itend 720
     set_namelist 1_namelist_cfg nn_stock 360
-    set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
 	
@@ -421,5 +415,4 @@
     set_namelist namelist_cfg nn_itend 240
     set_namelist namelist_cfg nn_stock 120
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg ln_rstart .true.
@@ -430,5 +423,4 @@
     set_namelist 1_namelist_cfg nn_it000 361
     set_namelist 1_namelist_cfg nn_itend 720
-    set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 1_namelist_cfg nn_stock 360
@@ -477,5 +469,4 @@
     set_namelist namelist_cfg jpni 2
     set_namelist namelist_cfg jpnj 3
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
    
@@ -486,5 +477,4 @@
     set_namelist 1_namelist_cfg jpni 2
     set_namelist 1_namelist_cfg jpnj 3
-    set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
 
@@ -515,5 +505,4 @@
     set_namelist namelist_cfg jpni 3
     set_namelist namelist_cfg jpnj 2
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
 
@@ -524,5 +513,4 @@
     set_namelist 1_namelist_cfg jpni 3
     set_namelist 1_namelist_cfg jpnj 2
-    set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
 
@@ -569,5 +557,4 @@
     set_namelist namelist_cfg nn_it000 1
     set_namelist namelist_cfg nn_itend 200
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg nn_stock 100
@@ -576,5 +563,4 @@
     set_namelist 1_namelist_cfg nn_it000 1
     set_namelist 1_namelist_cfg nn_itend 600
-    set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 1_namelist_cfg nn_stock 300
@@ -597,5 +583,4 @@
     set_namelist namelist_cfg nn_it000 101
     set_namelist namelist_cfg nn_itend 200
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg nn_stock 100
@@ -608,5 +593,4 @@
     set_namelist 1_namelist_cfg nn_it000 301
     set_namelist 1_namelist_cfg nn_itend 600
-    set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist 1_namelist_cfg nn_stock 300
@@ -663,5 +647,4 @@
     set_namelist namelist_cfg jpni 2
     set_namelist namelist_cfg jpnj 3
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     
@@ -672,5 +655,4 @@
     set_namelist 1_namelist_cfg jpni 2
     set_namelist 1_namelist_cfg jpnj 3
-    set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
 
@@ -701,5 +683,4 @@
     set_namelist namelist_cfg jpni 3
     set_namelist namelist_cfg jpnj 2
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     
@@ -710,5 +691,4 @@
     set_namelist 1_namelist_cfg jpni 3
     set_namelist 1_namelist_cfg jpnj 2
-    set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
     
@@ -757,5 +737,4 @@
     set_namelist namelist_cfg jpni 5
     set_namelist namelist_cfg jpnj 3
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -781,5 +760,4 @@
     set_namelist namelist_cfg jpni 5
     set_namelist namelist_cfg jpnj 3
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     set_namelist namelist_cfg cn_ocerst_in \"ISOMIP_LONG_00000048_restart\"
@@ -818,5 +796,4 @@
     set_namelist namelist_cfg jpni 7
     set_namelist namelist_cfg jpnj 3
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -844,5 +821,4 @@
     set_namelist namelist_cfg jpni 8
     set_namelist namelist_cfg jpnj 4
-    set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
     if [ ${USING_MPMD} == "yes" ] ; then