Index: /NEMO/branches/UKMO/dev_r12745_HPC-02_Daley_Tiling_trial_public/src/OCE/TRA/traldf.F90
===================================================================
--- /NEMO/branches/UKMO/dev_r12745_HPC-02_Daley_Tiling_trial_public/src/OCE/TRA/traldf.F90	(revision 12943)
+++ /NEMO/branches/UKMO/dev_r12745_HPC-02_Daley_Tiling_trial_public/src/OCE/TRA/traldf.F90	(revision 12944)
@@ -45,5 +45,5 @@
 CONTAINS
 
-   SUBROUTINE tra_ldf(kt, Kbb, Kmm, pts, Krhs )
+   SUBROUTINE tra_ldf( kt, Kbb, Kmm, pts, Krhs )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE tra_ldf  ***
@@ -58,5 +58,5 @@
       !!----------------------------------------------------------------------
       !
-         IF( ln_timing )   CALL timing_start('tra_ldf')
+      IF( ln_timing )   CALL timing_start('tra_ldf')
       !
       IF( ntile == 0 .OR. ntile == nijtile )  THEN                ! Do only after all tiles finish
@@ -91,9 +91,9 @@
          ENDIF
       ENDIF
-         !                                        !* print mean trends (used for debugging)
-         IF(sn_cfctl%l_prtctl)   CALL prt_ctl( tab3d_1=pts(:,:,:,jp_tem,Krhs), clinfo1=' ldf  - Ta: ', mask1=tmask,               &
-            &                                  tab3d_2=pts(:,:,:,jp_sal,Krhs), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         !
-         IF( ln_timing )   CALL timing_stop('tra_ldf')
+      !                                        !* print mean trends (used for debugging)
+      IF(sn_cfctl%l_prtctl)   CALL prt_ctl( tab3d_1=pts(:,:,:,jp_tem,Krhs), clinfo1=' ldf  - Ta: ', mask1=tmask,               &
+         &                                  tab3d_2=pts(:,:,:,jp_sal,Krhs), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+      !
+      IF( ln_timing )   CALL timing_stop('tra_ldf')
       !
    END SUBROUTINE tra_ldf
Index: /NEMO/branches/UKMO/dev_r12745_HPC-02_Daley_Tiling_trial_public/src/OCE/TRA/traldf_iso.F90
===================================================================
--- /NEMO/branches/UKMO/dev_r12745_HPC-02_Daley_Tiling_trial_public/src/OCE/TRA/traldf_iso.F90	(revision 12943)
+++ /NEMO/branches/UKMO/dev_r12745_HPC-02_Daley_Tiling_trial_public/src/OCE/TRA/traldf_iso.F90	(revision 12944)
@@ -321,16 +321,16 @@
          END_3D
          !
-            IF( ( kpass == 1 .AND. ln_traldf_lap ) .OR.  &     !==  first pass only (  laplacian)  ==!
-                ( kpass == 2 .AND. ln_traldf_blp ) ) THEN      !==  2nd   pass      (bilaplacian)  ==!
-               !
-               !                             ! "Poleward" diffusive heat or salt transports (T-S case only)
-                  ! note sign is reversed to give down-gradient diffusive transports )
-               ! TODO: TO BE TILED
-               IF( l_ptr )  CALL dia_ptr_hst( jn, 'ldf', -zftv(:,:,:)  )
-               !                          ! Diffusive heat transports
-               ! TODO: TO BE TILED
-               IF( l_hst )  CALL dia_ar5_hst( jn, 'ldf', -zftu(:,:,:), -zftv(:,:,:) )
-               !
-            ENDIF                                                    !== end pass selection  ==!
+         IF( ( kpass == 1 .AND. ln_traldf_lap ) .OR.  &     !==  first pass only (  laplacian)  ==!
+             ( kpass == 2 .AND. ln_traldf_blp ) ) THEN      !==  2nd   pass      (bilaplacian)  ==!
+            !
+            !                             ! "Poleward" diffusive heat or salt transports (T-S case only)
+               ! note sign is reversed to give down-gradient diffusive transports )
+            ! TODO: TO BE TILED
+            IF( l_ptr )  CALL dia_ptr_hst( jn, 'ldf', -zftv(:,:,:)  )
+            !                          ! Diffusive heat transports
+            ! TODO: TO BE TILED
+            IF( l_hst )  CALL dia_ar5_hst( jn, 'ldf', -zftu(:,:,:), -zftv(:,:,:) )
+            !
+         ENDIF                                                    !== end pass selection  ==!
          !
          !                                                        ! ===============